/*
	PiNKY Project : Execute Yahoo Pipelines on 1060 NetKernel!
    Copyright (C) 2007  Peter Rodgers

	GPL License Notice:
	
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License along
    with this program; if not, write to the Free Software Foundation, Inc.,
    51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
	
	1060 Public License Notice:
	 * This Software is licensed to You, the licensee, for use under the terms of
	 * the 1060 Public License v1.0. Please read and agree to the 1060 Public
	 * License v1.0 [www.1060research.com/license] before using or redistributing
	 * this software.
	 *
	 * In summary the 1060 Public license has the following conditions.
	 * A. You may use the Software free of charge provided you agree to the terms
	 * laid out in the 1060 Public License v1.0
	 * B. You are only permitted to use the Software with components or applications
	 * that provide you with OSI Certified Open Source Code [www.opensource.org], or
	 * for which licensing has been approved by 1060 Research Limited.
	 * You may write your own software for execution by this Software provided any
	 * distribution of your software with this Software complies with terms set out
	 * in section 2 of the 1060 Public License v1.0
	 * C. You may redistribute the Software provided you comply with the terms of
	 * the 1060 Public License v1.0 and that no warranty is implied or given.
	 * D. If you find you are unable to comply with this license you may seek to
	 * obtain an alternative license from 1060 Research Limited by contacting
	 * license@1060research.com or by visiting www.1060research.com
	 *
	 * NO WARRANTY:  THIS SOFTWARE IS NOT COVERED BY ANY WARRANTY. SEE 1060 PUBLIC
	 * LICENSE V1.0 FOR DETAILS
	 *
	 * THIS COPYRIGHT NOTICE IS *NOT* THE 1060 PUBLIC LICENSE v1.0. PLEASE READ
	 * THE DISTRIBUTED license.txt OR www.1060research.com/license

 
Created on 13 February 2007, 11:31
*/

package org.pinkypipes.accessor;

import java.util.List;

import org.pinkypipes.aspect.FeedAspect;
import org.pinkypipes.aspect.IAspectFeed;
import org.pinkypipes.aspect.EntryAspect;
import org.pinkypipes.aspect.IAspectEntry;
import org.ten60.netkernel.layer1.nkf.INKFConvenienceHelper;
import org.ten60.netkernel.layer1.nkf.INKFRequestReadOnly;
import org.ten60.netkernel.layer1.nkf.impl.NKFAccessorImpl;
import org.ten60.netkernel.layer1.nkf.INKFRequest;
import com.ten60.netkernel.util.NetKernelException;

import com.sun.syndication.feed.synd.SyndFeed;
import com.sun.syndication.feed.synd.SyndEntry;


/**
 * ForEachEntryAccessor - Implements two iterative services for processing feed entries, active:ForEachAnnotate and active:ForEachReplace
 * @author  pjr
 */
public class ForEachEntryAccessor extends NKFAccessorImpl
{
	
	/** Creates a new instance of ForEachEntryAccessor */
	public ForEachEntryAccessor()
	{	super(SAFE_FOR_CONCURRENT_USE, INKFRequestReadOnly.RQT_SOURCE);
	}
	
	public void processRequest(INKFConvenienceHelper context) throws Exception
	{	IAspectFeed fa=(IAspectFeed)context.sourceAspect("this:param:feed", IAspectFeed.class);
		String processuri=context.getThisRequest().getArgument("processuri");
		SyndFeed feed=fa.getFeed();
		List entries=feed.getEntries();
		boolean mode=context.getThisRequest().getActiveType().equals("ForEachReplace");
		for(int i=0; i< entries.size(); i++)
		{	SyndEntry e=(SyndEntry)entries.get(i);
			INKFRequest req=context.createSubRequest(processuri);
			req.addArgument("entry", new EntryAspect(e));
			if(mode)
			{	//Replace Mode
				req.setAspectClass(IAspectEntry.class);
				IAspectEntry response=(IAspectEntry)context.issueSubRequestForAspect(req);	
				entries.set(i, response.getEntry());
			}
			else
			{	//Append Mode
				throw new NetKernelException("Not Yet Implemented");
				
			}
		}
		fa=new FeedAspect(feed);
		context.createResponseFrom(fa);
	}
	
}
